///////////////////////////////////////////////////////////////////////
//CatMap AT auf bild mit 377x377 Pixel und Periode 14
////////////////////////////////////////////////////////////
PImage bild, neuesBild;
int N; //Bbreite in Pixel des quadratischen Bildes
int n; //obere Grenze der Anzahl der AT ("Arnold-Transformation")
int l; //untere Grenze der Anzahl der AT ("Arnold-Transformation")
int k;
int nummer;
int xAlt,yAlt,xNeu,yNeu;
color farbe;
boolean fertig,aufgerufen;

void settings(){
   bild = loadImage("bild.png");  
   N= bild.width;
   neuesBild = new PImage(N,N); 
   size(N,N); 
}

void setup() {
 image(bild,0,0);
 k =0;l = 0;
 n = 15; //Hier Periode 14 
 fertig = false;
 aufgerufen = false;
 nummer = 0;
 
}

///////////////////////////////////////////
PImage catMappen(PImage bild, int l){
 
  //über alle Pixel iterieren
  for (int j = 0; j < N; j++) {
   for (int i = 0; i < N; i++) {  
     farbe = bild.get(i,j);
     xAlt = i; yAlt = j;
      while (k<l) {    
          xNeu= (2*xAlt+yAlt)%N; 
          yNeu= (xAlt + yAlt)%N;      
          xAlt= xNeu; yAlt= yNeu;     
          k++;
     } 
     k=0;
     neuesBild.set(xAlt,yAlt,farbe);    
   }
 } 
  
 
  fertig = true; 
  aufgerufen = false;
  return neuesBild;
  
}
///////////////////////////////////////////////

void draw () { 
   if(!aufgerufen){// es werden 14 Transformationen durchgeführt.
      if(l<n){  
        catMappen(bild,l);
        delay(100);//Um besser zuschauen zu können
        l++;  
         aufgerufen = false;
      }
      
   } 
   if(fertig){ 
   
    image(neuesBild,0,0);//println(l,n);
    fertig = false;//println("fertig unten");
    nummer++;
    //save("data/bildAT"+nummer+".jpg");//Zum Speichern der Bilder
  }
  
 
}